
DataSection
  GradProgressDLL:
  IncludeBinary "GradProgress.dll"
EndDataSection

LoadLibraryM(?GradProgressDLL)

Enumeration ; #UPM_MESSAGEBASE
  #UPM_MESSAGEBASE	= $600
  #UPM_SETBARCOLOR1	= #UPM_MESSAGEBASE + $00
  #UPM_SETBARCOLOR2	= #UPM_MESSAGEBASE + $01
  #UPM_SETBARCOLORS	= #UPM_MESSAGEBASE + $02
  #UPM_SETRANGE		  = #UPM_MESSAGEBASE + $03
  #UPM_SETPOS			  = #UPM_MESSAGEBASE + $04
  #UPM_SETSTEP			= #UPM_MESSAGEBASE + $05
  #UPM_STEPIT			  = #UPM_MESSAGEBASE + $06
  #UPM_GETBARCOLOR1	= #UPM_MESSAGEBASE + $07
  #UPM_GETBARCOLOR2	= #UPM_MESSAGEBASE + $08
  #UPM_GETRANGE		  = #UPM_MESSAGEBASE + $09
  #UPM_GETPOS			  = #UPM_MESSAGEBASE + $0A
  #UPM_GETSTEP			= #UPM_MESSAGEBASE + $0B
  #UPM_RANDOMCOLOR	= #UPM_MESSAGEBASE + $0C
  #UPM_RAINIT			  = #WM_USER + 9999
EndEnumeration

Procedure GradProgress_GetGadgetColor(*Gadget.PB_Gadget, Type)
  Select Type
    Case #PB_Gadget_FrontColor
      ProcedureReturn SendMessage_(*Gadget\Gadget, #UPM_GETBARCOLOR1, 0, 0)
    Case #PB_Gadget_BackColor
      ProcedureReturn SendMessage_(*Gadget\Gadget, #UPM_GETBARCOLOR2, 0, 0)
  EndSelect
EndProcedure

Procedure GradProgress_SetGadgetColor(*Gadget.PB_Gadget, Type, Color)
  Select Type
    Case #PB_Gadget_FrontColor
      SendMessage_(*Gadget\Gadget, #UPM_SETBARCOLOR1, Color, 0)
    Case #PB_Gadget_BackColor
      SendMessage_(*Gadget\Gadget, #UPM_SETBARCOLOR2, Color, 0)
    Default
      SendMessage_(*Gadget\Gadget, #UPM_RANDOMCOLOR, Color, 0)
  EndSelect
  InvalidateRect_(*Gadget\Gadget, 0, 1)
EndProcedure

Procedure GradProgress_GetGadgetAttribute(*Gadget.PB_Gadget, Attribute)
  ProcedureReturn SendMessage_(*Gadget\Gadget, Attribute, 0, 0)
EndProcedure

Procedure GradProgress_SetGadgetAttribute(*Gadget.PB_Gadget, Attribute, Value)
  SendMessage_(*Gadget\Gadget, Attribute, Value, 0)
  InvalidateRect_(*Gadget\Gadget, 0, 1)
EndProcedure

Procedure GradProgress_GetGadgetState(*Gadget.PB_Gadget)
  ProcedureReturn SendMessage_(*Gadget\Gadget, #UPM_GETPOS, 0, 0)
EndProcedure

Procedure GradProgress_SetGadgetState(*Gadget.PB_Gadget, State)
  SendMessage_(*Gadget\Gadget, #UPM_SETPOS, State, 0)
  InvalidateRect_(*Gadget\Gadget, 0, 1)
EndProcedure

Procedure GradProgressBarGadget(Id.l, x.l, y.l, cx.l, cy.l, max.l)
  Protected Gadget.l, hWnd.l
  Protected VT.PB_GadgetVT
  VT\GadgetType = #PB_GadgetType_Unknown
  VT\GetGadgetAttribute = @GradProgress_GetGadgetAttribute()
  VT\SetGadgetAttribute = @GradProgress_SetGadgetAttribute()
  VT\GetGadgetColor = @GradProgress_GetGadgetColor()
  VT\SetGadgetColor = @GradProgress_SetGadgetColor()
  VT\GetGadgetState = @GradProgress_GetGadgetState()
  VT\SetGadgetState = @GradProgress_SetGadgetState()
  Gadget = CreateGadget(Id, "TxPROGRESS", "", $50000000, x, y, cx, cy, 0, 0, @VT)
  If Id = #PB_Any
    hWnd = GadgetID(Gadget)
  Else
    hWnd = Gadget
  EndIf
  SendMessage_(hWnd, #UPM_SETRANGE, max, 0)
  ProcedureReturn Gadget
EndProcedure
