
Prototype.l PB_Gadget_SendGadgetCommand(hWnd.l,EventType.l)

Structure COLUMN
  colwt.l						     ;Column width.
  lpszhdrtext.l					 ;Pointer to header text.
  halign.l						   ;Header text alignment.
  calign.l						   ;Column text alignment.
  ctype.l						     ;Column data type.
  ctextmax.l					   ;Max text lenght for TYPE_EDITTEXT and TYPE_EDITLONG.
  lpszformat.l					 ;Format string for TYPE_EDITLONG.
  himl.l						     ;Handle of image list. For the image columns and combobox only.
  hdrflag.l						   ;Header flags. Set to ZERO or if initially sorted set to initial sort direction
  colxp.l						     ;Column position. Internally used.
  edthwnd.l						   ;Column control handle. Internally used.
  lParam.l						   ;User defined 32 bit value.
EndStructure

Structure ROWCOLOR
  backcolor.l
  textcolor.l
EndStructure

Structure GRIDNOTIFY
  nmhdr.NMHDR
  col.l			      ;Column
  row.l			      ;Row
  hwnd.l			    ;Handle of column edit control
  lpdata.l		    ;Pointer to data
  fcancel.l		    ;Set to TRUE to cancel operation
EndStructure

;Messages
#GM_ADDCOL			    = #WM_USER+1	;wParam=0, lParam=lpCOLUMN
#GM_ADDROW			    = #WM_USER+2	;wParam=0, lParam=lpROWDATA (can be NULL)
#GM_INSROW			    = #WM_USER+3	;wParam=nRow, lParam=lpROWDATA (can be NULL)
#GM_DELROW			    = #WM_USER+4	;wParam=nRow, lParam=0
#GM_MOVEROW			    = #WM_USER+5	;wParam=nFromRow, lParam=nToRow
#GM_COMBOADDSTRING	= #WM_USER+6	;wParam=nCol, lParam=lpszString
#GM_COMBOCLEAR		  = #WM_USER+7	;wParam=nCol, lParam=0
#GM_GETCURSEL		    = #WM_USER+8	;wParam=0, lParam=0
#GM_SETCURSEL		    = #WM_USER+9	;wParam=nCol, lParam=nRow
#GM_GETCURCOL		    = #WM_USER+10	;wParam=0, lParam=0
#GM_SETCURCOL		    = #WM_USER+11	;wParam=nCol, lParam=0
#GM_GETCURROW		    = #WM_USER+12	;wParam=0, lParam=0
#GM_SETCURROW		    = #WM_USER+13	;wParam=nRow, lParam=0
#GM_GETCOLCOUNT		  = #WM_USER+14	;wParam=0, lParam=0
#GM_GETROWCOUNT		  = #WM_USER+15	;wParam=0, lParam=0
#GM_GETCELLDATA		  = #WM_USER+16	;wParam=nRowCol, lParam=lpData
#GM_SETCELLDATA		  = #WM_USER+17	;wParam=nRowCol, lParam=lpData (can be NULL)
#GM_GETCELLRECT		  = #WM_USER+18	;wParam=nRowCol, lParam=lpRECT
#GM_SCROLLCELL		  = #WM_USER+19	;wParam=0, lParam=0
#GM_GETBACKCOLOR		= #WM_USER+20	;wParam=0, lParam=0
#GM_SETBACKCOLOR		= #WM_USER+21	;wParam=nColor, lParam=0
#GM_GETGRIDCOLOR		= #WM_USER+22	;wParam=0, lParam=0
#GM_SETGRIDCOLOR		= #WM_USER+23	;wParam=nColor, lParam=0
#GM_GETTEXTCOLOR		= #WM_USER+24	;wParam=0, lParam=0
#GM_SETTEXTCOLOR		= #WM_USER+25	;wParam=nColor, lParam=0
#GM_ENTEREDIT		    = #WM_USER+26	;wParam=nCol, lParam=nRow
#GM_ENDEDIT			    = #WM_USER+27	;wParam=nRowCol, lParam=fCancel
#GM_GETCOLWIDTH		  = #WM_USER+28	;wParam=nCol, lParam=0
#GM_SETCOLWIDTH		  = #WM_USER+29	;wParam=nCol, lParam=nWidth
#GM_GETHDRHEIGHT		= #WM_USER+30	;wParam=0, lParam=0
#GM_SETHDRHEIGHT		= #WM_USER+31	;wParam=0, lParam=nHeight
#GM_GETROWHEIGHT		= #WM_USER+32	;wParam=0, lParam=0
#GM_SETROWHEIGHT		= #WM_USER+33	;wParam=0, lParam=nHeight
#GM_RESETCONTENT		= #WM_USER+34	;wParam=0, lParam=0
#GM_COLUMNSORT		  = #WM_USER+35	;wParam=nCol, lParam=0=Ascending, 1=Descending, 2=Invert
#GM_GETHDRTEXT		  = #WM_USER+36	;wParam=nCol, lParam=lpBuffer
#GM_SETHDRTEXT		  = #WM_USER+37	;wParam=nCol, lParam=lpszText
#GM_GETCOLFORMAT		= #WM_USER+38	;wParam=nCol, lParam=lpBuffer
#GM_SETCOLFORMAT		= #WM_USER+39	;wParam=nCol, lParam=lpszText
#GM_CELLCONVERT		  = #WM_USER+40	;wParam=nRowCol, lParam=lpBuffer
#GM_RESETCOLUMNS		= #WM_USER+41	;wParam=0, lParam=0
#GM_GETROWCOLOR		  = #WM_USER+42	;wParam=nRow, lParam=lpROWCOLOR
#GM_SETROWCOLOR		  = #WM_USER+43	;wParam=nRow, lParam=lpROWCOLOR
#GM_GETCOLDATA		  = #WM_USER+44	;wParam=nCol, lParam=lpCOLUMN

;Column alignment
#GA_ALIGN_LEFT		  = 0
#GA_ALIGN_CENTER		= 1
#GA_ALIGN_RIGHT		  = 2

;Column types
#TYPE_EDITTEXT		  = 0			;String
#TYPE_EDITLONG		  = 1			;Long
#TYPE_CHECKBOX		  = 2			;Long
#TYPE_COMBOBOX		  = 3			;Long
#TYPE_HOTKEY			  = 4			;Long
#TYPE_BUTTON			  = 5			;String
#TYPE_IMAGE			    = 6			;Long
#TYPE_DATE			    = 7			;Long
#TYPE_TIME			    = 8			;Long
#TYPE_USER			    = 9			;0=String, 1 to 512 bytes binary data
#TYPE_EDITBUTTON		= 10		;String

;Column sorting
#SORT_ASCENDING		  = 0
#SORT_DESCENDING	  = 1
#SORT_INVERT			  = 2

;Window styles
#STYLE_NOSEL			  = $01
#STYLE_NOFOCUS		  = $02
#STYLE_HGRIDLINES	  = $04
#STYLE_VGRIDLINES	  = $08
#STYLE_GRIDFRAME		= $10
#STYLE_NOCOLSIZE		= $20

#ODT_GRID			= 6

#PB_EventType_Grid_HeaderClick		  = 1			;User clicked header
#PB_EventType_Grid_ButtonClick		  = 2			;Sendt when user clicks the button in a button cell
#PB_EventType_Grid_CheckClick		    = 3			;Sendt when user double clicks the checkbox in a checkbox cell
#PB_EventType_Grid_ImageClick		    = 4			;Sendt when user double clicks the image in an image cell
#PB_EventType_Grid_BeforeSelChange	= 5			;Sendt when user request a selection change
#PB_EventType_Grid_AfterSelChange   = 6			;Sendt after a selection change
#PB_EventType_Grid_BeforeEdit	      = 7			;Sendt before the cell edit control shows
#PB_EventType_Grid_AfterEdit		    = 8			;Sendt when the cell edit control is about to close
#PB_EventType_Grid_BeforeUpdate		  = 9			;Sendt before a cell updates grid data
#PB_EventType_Grid_AfterUpdate		  = 10		;Sendt after grid data has been updated
#PB_EventType_Grid_UserConvert		  = 11		;Sendt when user cell needs to be converted.

Import "RaGrid.res" : EndImport

Import "RAGrid.lib"
  GridInstall(hInstance)
EndImport

GridInstall(GetModuleHandle_(0))

;-
;-  SortGridColumn(pbid.l,col,typ.l = 0)  ; Sort column
;-
Procedure SortGridColumn(pbid.l,col,typ.l = 0)
  Protected *gadget.PB_Gadget = IsGadget(pbid)
  If *Gadget
    ProcedureReturn SendMessage_(*Gadget\Gadget,#GM_COLUMNSORT,Col,typ)
  EndIf
EndProcedure

;-
;-  AddGridColumn(pbid.l,Text.s,cx.l,typ.l,flags=0) ; set header/column
;-
Procedure AddGridColumn(pbid.l,Text.s,cx.l,typ.l,flags=0)
  Protected col.COLUMN
  Protected *gadget.PB_Gadget = IsGadget(pbid)

  If *Gadget

    col\hdrflag     = #SORT_ASCENDING
    col\colwt       = cx
    col\lpszhdrtext = @Text
    col\calign      = #GA_ALIGN_CENTER
    col\ctype       = typ
    col\ctextmax    = 30

    ProcedureReturn SendMessage_(*Gadget\Gadget,#GM_ADDCOL,0,@col)

  EndIf
EndProcedure

;-
;-  AddGadgetGridItem(pbid.l,daten.l) ; Set Row
;-
Procedure AddGadgetGridItem(pbid.l,daten.l)
  Protected *gadget.PB_Gadget = IsGadget(pbid)
  If *Gadget
    ProcedureReturn SendMessage_(*Gadget\Gadget,#GM_ADDROW,0,daten)
  EndIf
EndProcedure

;-
;-  GetGridRow(pbid.l) ; return selected row
;-
Procedure GetGridRow(pbid.l)
  Protected *gadget.PB_Gadget = IsGadget(pbid)
  If *Gadget
    ProcedureReturn SendMessage_(*Gadget\Gadget,#GM_GETCURROW,0,0)
  EndIf
EndProcedure


;-
;-  GetGridCol(pbid.l) ; return selected column
;-
Procedure GetGridCol(pbid.l)
  Protected *gadget.PB_Gadget = IsGadget(pbid)
  If *Gadget
    ProcedureReturn SendMessage_(*Gadget\Gadget,#GM_GETCURCOL,0,0)
  EndIf
EndProcedure

;-
;-  AddGridComboString(pbid.l,col.l,Text.s)
;-
Procedure AddGridComboString(pbid.l,col.l,Text.s)
  Protected *gadget.PB_Gadget = IsGadget(pbid)
  If *Gadget
    ProcedureReturn SendMessage_(*Gadget\Gadget,#GM_COMBOADDSTRING,col,@Text)
  EndIf
EndProcedure

Procedure Grid_Callback(*Gadget.PB_Gadget,hWnd.l,uMsg.l,wParam.l,lParam.l)
  Protected *notify.GRIDNOTIFY
  Protected PBID = GetProp_(*Gadget\Gadget,"PB_ID")
  Protected PB_Gadget_SendGadgetCommand.PB_Gadget_SendGadgetCommand

  !Extrn _PB_Gadget_SendGadgetCommand@8
  !Mov   [p.v_PB_Gadget_SendGadgetCommand],dword _PB_Gadget_SendGadgetCommand@8

  If uMsg = #WM_NOTIFY
    *notify = lParam

    Select *notify\nmhdr\code
      Case #PB_EventType_Grid_HeaderClick
         PB_Gadget_SendGadgetCommand(*Gadget\Gadget,#PB_EventType_Grid_HeaderClick)
      Case #PB_EventType_Grid_ButtonClick
        PB_Gadget_SendGadgetCommand(*Gadget\Gadget,#PB_EventType_Grid_ButtonClick)
      Case #PB_EventType_Grid_CheckClick
         PB_Gadget_SendGadgetCommand(*Gadget\Gadget,#PB_EventType_Grid_CheckClick)
      Case #PB_EventType_Grid_ImageClick
         PB_Gadget_SendGadgetCommand(*Gadget\Gadget,#PB_EventType_Grid_ImageClick)
      Case #PB_EventType_Grid_BeforeSelChange
         PB_Gadget_SendGadgetCommand(*Gadget\Gadget,#PB_EventType_Grid_BeforeSelChange)
      Case #PB_EventType_Grid_AfterSelChange
         PB_Gadget_SendGadgetCommand(*Gadget\Gadget,#PB_EventType_Grid_AfterSelChange)
      Case #PB_EventType_Grid_BeforeEdit
         PB_Gadget_SendGadgetCommand(*Gadget\Gadget,#PB_EventType_Grid_BeforeEdit)
      Case #PB_EventType_Grid_AfterEdit
         PB_Gadget_SendGadgetCommand(*Gadget\Gadget,#PB_EventType_Grid_AfterEdit)
      Case #PB_EventType_Grid_BeforeUpdate
         PB_Gadget_SendGadgetCommand(*Gadget\Gadget,#PB_EventType_Grid_BeforeUpdate)
      Case #PB_EventType_Grid_AfterUpdate
         PB_Gadget_SendGadgetCommand(*Gadget\Gadget,#PB_EventType_Grid_AfterUpdate)
      Case #PB_EventType_Grid_UserConvert
        PB_Gadget_SendGadgetCommand(*Gadget\Gadget,#PB_EventType_Grid_UserConvert)
    EndSelect

  EndIf

EndProcedure

Procedure GridGadget(ID.l,x.l,y.l,cx.l,cy.l,flags=0)
  Protected vt.PB_GadgetVT

  vt\GadgetType       = #PB_GadgetType_Unknown
  vt\GadgetCallback   = @Grid_Callback()

  ProcedureReturn CreateGadget(ID, "MyRAGrid", "", flags|#WS_VISIBLE|#WS_CHILD, x, y, cx, cy, #WS_EX_STATICEDGE, 0, @vt)
EndProcedure
