; IncludeFile "pbosl_msxml3.pb"
; 
; CallDebugger
; 
; MSXML3_Init()

; Initial erstellen wir ein Objekt vom Type DOMDocument

oDoc = MSXML3_CreateDomDocument()

If oDoc
  
  ; Jetzt bauen wir uns ein XML-Dokument im Speicher zusammen
  
  sXML.s = "<adressen>" + #CRLF$
  sXML.s + "  <adresse>" + #CRLF$
  sXML.s + "    <name>Donald Duck</name>" + #CRLF$
  sXML.s + "    <strasse>Erpelweg 10</strasse>" + #CRLF$
  sXML.s + "    <ort>Entenhausen</ort>" + #CRLF$
  sXML.s + "  </adresse>" + #CRLF$
  sXML.s + "  <adresse>" + #CRLF$
  sXML.s + "    <name>Batman</name>" + #CRLF$
  sXML.s + "    <strasse>Fledermausgasse 99</strasse>" + #CRLF$
  sXML.s + "    <ort>Gotham City</ort>" + #CRLF$
  sXML.s + "  </adresse>" + #CRLF$
  sXML.s + "</adressen>"
  
  ; ... und laden es in das DOMDocument-Objekt
  
  If MSXML3_LoadXML(oDoc, sXML)
    
    MessageRequester("XML erfolgreich in das DOMDocument-Objekt geladen",  MSXML3_GetXml(oDoc))
    
    ; Hier fhren wir auf dem DOMDocument die Methode 'SelectSingleNode' aus.
    ; Der erste Parameter ist der Pfad (XPath), den wir auslesen mchten.
    
    oNode = MSXML3_SelectSingleNode(oDoc, "adressen/adresse[name='Batman']")
    
    If oNode  
      
      ; Nun haben wir ein Objekt vom Typ XMLNode, welches die Adresse von Batman beinhaltet.
      
      MessageRequester("Selektierte Adresse:", MSXML3_GetXml(oNode))
      
      MSXML3_ReleaseObject(oNode)
      
    EndIf
    
    
  Else
    
    ; Sollte das Laden des XML-Dokumentes fehlschlagen, so knnen wir ParseError auswerten
    
    Msg$ = "ErrorCode: " + Str(MSXML3_GetParseErrorErrorcode(oDoc)) + #CRLF$
    Msg$ + "Beschreibung: " + MSXML3_GetParseErrorReason(oDoc) + #CRLF$
    Msg$ + "Source: " + MSXML3_GetParseErrorSrctext(oDoc) + #CRLF$
    Msg$ + "Fehlerzeile: " + Str(MSXML3_GetParseErrorLine(oDoc)) + #CRLF$
    Msg$ + "Fehlerposition: " + Str(MSXML3_GetParseErrorLinepos(oDoc)) + #CRLF$
    
    MessageRequester("XML konnte nicht in das DOMDocument-Objekt geladen werden", Msg$)
    
  EndIf
  
  ; Letztendlich geben wir das DOMDocument-Objekt wieder frei
  
  MSXML3_ReleaseObject(oDoc)
  
Else
  
  MessageRequester("Initialisierung fehlgeschlagen", "Es konnte kein DOMDocument-Objekt erstellt werden")
  
EndIf

