Macro HiWord(long)
  (long >> 16) & $FFFF
EndMacro

Macro LoWord(long)
  long & $FFFF
EndMacro

Structure Event
  event.l
  subevent1.l
  subevent2.l
  Proc.l
  dwData.l
EndStructure

Enumeration #WM_USER + 1000
  #OnClick
  #OnFokus
  #OnMouseMove
EndEnumeration

Procedure ButtonEventCallback(hwnd,uMsg,wParam,lParam,uId,*dwData.Event)
  
  If *dwData\event = #WM_COMMAND And lParam = uId
    If HiWord(wParam) = *dwData\subevent1
      CallFunctionFast(*dwData\Proc,hwnd,wParam,lParam)
    EndIf
  EndIf
  
  If *dwData\event = #WM_MOUSEMOVE And uMsg = #WM_MOUSEMOVE
    CallFunctionFast(*dwData\Proc,hwnd,wParam,lParam)
  EndIf
  
  ProcedureReturn DefSubclassProc(hwnd, uMsg , wParam, lParam)
EndProcedure

Procedure SetEvent(hwnd,ev,Proc)
  Protected Buffer.s
  Protected *evh.Event
  
  id = ev
  
  Select ev
    Case #OnClick
      Buffer = Space(128)
      GetClassName_(hwnd,Buffer,128)
      If LCase(Buffer) = "button"
        id        = hwnd
        hwnd      = GetParent_(hwnd)
        event     = #WM_COMMAND
        subevent1 = #BN_CLICKED
        evhp      = @ButtonEventCallback()
      EndIf
    Case #OnFokus
      Buffer = Space(128)
      GetClassName_(hwnd,Buffer,128)
      If LCase(Buffer) = "button"
        id        = hwnd
        style = GetWindowLong_(hwnd,#GWL_STYLE)
        SetWindowLong_(hwnd,#GWL_STYLE,style|$4000) ; #BS_NOTIFY
        hwnd      = GetParent_(hwnd)
        event     = #WM_COMMAND
        subevent1 = #BN_SETFOCUS
        evhp      = @ButtonEventCallback()
      EndIf
    Case #OnMouseMove
      event     = #WM_MOUSEMOVE
      evhp      = @ButtonEventCallback()
  EndSelect
  
  GetWindowSubclass(hwnd,evhp,id,@*evh)
  
  If Not *evh
    *evh = AllocateMemory(SizeOf(Event))
  EndIf
  
  *evh\event     = event
  *evh\subevent1 = subevent1
  *evh\Proc      = Proc
  
  ProcedureReturn SetWindowSubclass(hwnd,evhp,id,*evh)
EndProcedure

Procedure OnClick_button1(hwnd,wParam,lParam)
  Debug "OnClick_button1"
EndProcedure

Procedure OnClick_button2(hwnd,wParam,lParam)
  Debug "OnClick_button2"
EndProcedure

Procedure MouseMove_button2(hwnd,wParam,lParam)
  Debug "MouseMove_button2"
EndProcedure

hwnd = OpenWindow(0,0,0,200,200,"",#WS_OVERLAPPEDWINDOW|#PB_Window_ScreenCentered)

CreateGadgetList(hwnd)
button0 = ButtonGadget(0, 10, 10, 80, 30, "bla")
button1 = ButtonGadget(1, 10, 40, 80, 30, "bla")

SetEvent(button0,#OnClick,@OnClick_button1())
SetEvent(button1,#OnClick,@OnClick_button2())
SetEvent(button1,#OnMouseMove,@MouseMove_button2())

Repeat : Until WaitWindowEvent() = 16

; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 29
; FirstLine = 29
; Folding = --
; EnableXP
; HideErrorLog